## ros-foxy-sick-scan2 0.1.9

=== CMakeLists.txt ===
###########################################################
# ROS2 CMakeLists.txt for SICK-Scanner-Support
#
# Project: sick_scan2
# URL: https://github.com/SICKAG/sick_scan2
#
###########################################################

cmake_minimum_required(VERSION 3.5)

project(sick_scan2)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
# TODO: Remove compiler warning from the code - currently suppressed

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wno-sign-compare )
#  add_compile_options(-Wall -Wextra -Wpedantic)
endif()


#uncomment this lines and change path accordingly
set(FastRTPS_INCLUDE_DIR /opt/ros/foxy/include)
set(FastRTPS_LIBRARY_RELEASE /opt/ros/foxy/lib/libfastrtps.so)
#to fix
#CMake Error at /snap/clion/126/bin/cmake/linux/share/cmake-3.17/Modules/FindPackageHandleStandardArgs.cmake:164 (message):
#  Could NOT find FastRTPS (missing: FastRTPS_INCLUDE_DIR FastRTPS_LIBRARIES)


# find_package(Boost REQUIRED COMPONENTS system thread)
find_package(ament_cmake REQUIRED)
# find_package(diagnostic_updater REQUIRED)
find_package(rclcpp REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(tf2 REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(tf2_ros REQUIRED)  

add_definitions(-DUSE_DYN_RECONFIG=0)

if(BUILD_WITH_LDMRS_SUPPORT OR BUILD_WITH_LDMRS_SUPPORT MATCHES "true")
        message(STATUS "Building sick_scan2 with LDMRS support")
        add_definitions(-DLDMRS_SUPPORT=1)
        find_package(rosidl_default_generators REQUIRED)
        find_package(SickLDMRS REQUIRED)
        rosidl_generate_interfaces(${PROJECT_NAME}
            "msg/ldmrs/SickLdmrsObject.msg"
            "msg/ldmrs/SickLdmrsObjectArray.msg"
            DEPENDENCIES builtin_interfaces std_msgs geometry_msgs sensor_msgs
        )
        find_package(PCL REQUIRED) # workaround https://github.com/ros2/rosidl/issues/402 : Do find_package(PCL) after calling rosidl_generate_interfaces in your CMakeLists.txt
        set(LDMRS_INCLUDES ${SICK_LDMRS_INCLUDE_DIRS} ${PCL_INCLUDE_DIRS})
        set(LDMRS_SOURCES driver/src/ldmrs/sick_ldmrs_config.cpp driver/src/ldmrs/sick_ldmrs_driver.cpp driver/src/ldmrs/sick_ldmrs_node.cpp)
        set(LDMRS_TARGET_DEPENDENCIES SickLDMRS)
        message(STATUS "LDMRS_INCLUDES: ${LDMRS_INCLUDES}")
        message(STATUS "LDMRS_SOURCES: ${LDMRS_SOURCES}")
        message(STATUS "LDMRS_TARGET_DEPENDENCIES: ${LDMRS_TARGET_DEPENDENCIES}")
endif()

find_package(Boost REQUIRED COMPONENTS system thread) # rosidl_generate_interfaces overwrites ${Boost_LIBRARIES}. Workaround: Do find_package(Boost ) after calling rosidl_generate_interfaces in CMakeLists.txt

if(BUILD_WITH_TEST_SERVER OR BUILD_WITH_TEST_SERVER MATCHES "true")
        message(STATUS "Building sick_scan2 with test server support")
        set(TEST_SERVER_INCLUDES tools/test_server/include) 
endif()

include_directories(include ${Boost_INCLUDE_DIR} ${LDMRS_INCLUDES} ${TEST_SERVER_INCLUDES})

add_library(sick_scan2_lib
        driver/src/sick_generic_laser.cpp
        driver/src/sick_generic_parser.cpp
        driver/src/sick_scan_common_tcp.cpp
        driver/src/sick_scan_common.cpp
        driver/src/tcp/tcp.cpp
        driver/src/tcp/Mutex.cpp
        driver/src/tcp/SickThread.cpp
        driver/src/tcp/errorhandler.cpp
        driver/src/tcp/toolbox.cpp
        driver/src/tcp/Time.cpp
        driver/src/tcp/colaa.cpp
        driver/src/tcp/colab.cpp
        driver/src/binPrintf.cpp
        driver/src/binScanf.cpp
        driver/src/sick_scan_common_nw.cpp
        driver/src/sick_generic_imu.cpp
        driver/src/softwarePLL.cpp
        ${LDMRS_SOURCES}
) 

ament_target_dependencies(
        sick_scan2_lib
        "Boost"
        "rclcpp"
        "sensor_msgs"
        "std_msgs"
        "geometry_msgs"
        "diagnostic_msgs" 
        "tf2_ros" 
        ${LDMRS_TARGET_DEPENDENCIES}
)

add_executable(sick_generic_caller
        driver/src/sick_generic_caller.cpp
        )

ament_target_dependencies(
        sick_generic_caller
        "Boost"
        # "diagnostic_updater"
        "rclcpp"
        "sensor_msgs"
        "std_msgs"
        "geometry_msgs"
        "diagnostic_msgs" 
        "tf2_ros" 
        ${LDMRS_TARGET_DEPENDENCIES}
)

#add_executable(quat_test
#        tools/quat_test/quat_test.cpp
#        include/sick_scan/sick_generic_imu.h
#        include/sick_scan/softwarePLL.h)

#ament_target_dependencies(quat_test
#        "rclcpp"
#        "tf2"
#        )

if(BUILD_WITH_LDMRS_SUPPORT OR BUILD_WITH_LDMRS_SUPPORT MATCHES "true")
        rosidl_target_interfaces(sick_scan2_lib ${PROJECT_NAME} "rosidl_typesupport_cpp")
        rosidl_target_interfaces(sick_generic_caller ${PROJECT_NAME} "rosidl_typesupport_cpp")
        target_link_libraries(sick_generic_caller sick_scan2_lib ${SICK_LDMRS_LIBRARIES} ${Boost_LIBRARIES})
else()        
        target_link_libraries(sick_generic_caller sick_scan2_lib)
endif()

if(BUILD_WITH_TEST_SERVER OR BUILD_WITH_TEST_SERVER MATCHES "true")
        add_executable(test_server 
            tools/test_server/src/test_server.cpp 
            tools/test_server/src/test_server_cola_msg.cpp 
            tools/test_server/src/test_server_ldmrs_msg.cpp 
            tools/test_server/src/test_server_thread.cpp)
        target_link_libraries(test_server sick_scan2_lib ${SICK_LDMRS_LIBRARIES} ${Boost_LIBRARIES})
        ament_target_dependencies(test_server "rclcpp")
        install(TARGETS 
            test_server
            DESTINATION lib/${PROJECT_NAME})
        install(DIRECTORY 
            tools/test_server/config
            tools/test_server/launch
            DESTINATION share/${PROJECT_NAME})
endif()

install(TARGETS
  sick_generic_caller
  DESTINATION lib/${PROJECT_NAME})

# Install launch files.
install(DIRECTORY
        launch
        config
        DESTINATION share/${PROJECT_NAME})


if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

=== debian/changelog ===
ros-foxy-sick-scan2 (0.1.9-1focal) focal; urgency=high

  * tf2-ros dependency added, temperatur to test server added
  * Contributors: Michael Lehning

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 21 Oct 2020 22:00:00 -0000

ros-foxy-sick-scan2 (0.1.8-1focal) focal; urgency=high

  * LDMRS support added scanner simulator added
  * migraded print statments to ros2
  * implemeted software pll and rssi
  * MRS 1xxx Imu support activated
  * added MRS1104 support
  * Update clion debugging
  * Adding TiM240 support info.
  * support of TiM240
  * prepare TiM240
    Correct parameter name "max_ang" in config files to activate the setting.
  * Modify max-ang to max_ang in config files.
  * Supported hardware list extended
  * added new launchfiles and updated readme
  * tf2 added
  * First draft of LMS511 and LMS111 support and pointcloud2
  * Quaternion test added
  * Contributors: Michael Lehning, Skyler Pan

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 21 Oct 2020 22:00:00 -0000

ros-foxy-sick-scan2 (0.1.7-1focal) focal; urgency=high

  * retrial bloom release
  * Merge pull request #8 <https://github.com/SICKAG/sick_scan2/issues/8> from clalancette/fixes
    Fixes for CMakeLists.txt to build on the buildfarm.
  * Fixes for CMakeLists.txt to build on the buildfarm.
    A few things done in here:
    1.  Change CMake required version back to 3.5
    2.  Remove unnecessary dependency on pthreads
    3.  Remove duplicate boost dependency.
    4.  Make sure to find_package(diagnostic_updater) before use.
    Signed-off-by: Chris Lalancette <mailto:clalancette@openrobotics.org>
  * Trying to figure out problem with the build farm
    build farm reports: 23:10:29 /usr/bin/ld: cannot find -lpthreads
  * -pthread option added to build receipt
  * Add pthreads dependancy
    This addition is triggered by reading
    'https://stackoverflow.com/questions/31948521/building-error-using-cmake-cannot-find-lpthreads'
  * pthread dep. added to CMakeLists.txt
  * removed unnecessary dependency from cmakelist.txt
  * Contributors: Chris Lalancette, Michael Lehning

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 15 Apr 2020 22:00:00 -0000

ros-foxy-sick-scan2 (0.1.6-1focal) focal; urgency=high

  * New retrial of bloom release

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 15 Apr 2020 22:00:00 -0000

ros-foxy-sick-scan2 (0.1.3-1focal) focal; urgency=high

  * Integration of TiM781 and TiM781S

 -- Michael Lehning <michael.lehning@lehning.de>  Tue, 22 Oct 2019 22:00:00 -0000

ros-foxy-sick-scan2 (0.1.2-1focal) focal; urgency=high

  * Porting to "Dashing"

 -- Michael Lehning <michael.lehning@lehning.de>  Mon, 21 Oct 2019 22:00:00 -0000

ros-foxy-sick-scan2 (0.1.1-1focal) focal; urgency=high

  * Integration Test for Bloom

 -- Michael Lehning <michael.lehning@lehning.de>  Mon, 21 Oct 2019 22:00:00 -0000

ros-foxy-sick-scan2 (0.1.0-1focal) focal; urgency=high

  * First version of a ROS2 driver for the SICK TiM family.

 -- Michael Lehning <michael.lehning@lehning.de>  Mon, 21 Oct 2019 22:00:00 -0000

=== debian/control ===
Source: ros-foxy-sick-scan2
Section: misc
Priority: optional
Maintainer: Michael Lehning <michael.lehning@lehning.de>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-diagnostic-updater, ros-foxy-rclcpp, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-tf2, ros-foxy-tf2-ros, ros-foxy-ros-workspace, ros-foxy-rosidl-typesupport-connext-c, ros-foxy-rosidl-typesupport-connext-cpp, ros-foxy-rosidl-typesupport-fastrtps-c, ros-foxy-rosidl-typesupport-fastrtps-cpp
Homepage: http://wiki.ros.org/sick_scan2
Standards-Version: 3.9.2

Package: ros-foxy-sick-scan2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-foxy-diagnostic-updater, ros-foxy-rclcpp, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-tf2, ros-foxy-tf2-ros, ros-foxy-ros-workspace
Description: A ROS2 driver for the SICK TiM series of laser scanners.
 This package is based on the sick_scan-Repository.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-sick-scan2//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
